classdef Packet < DataStream
    properties
        packetType;
        counter;
        
        nGlobalVariables;
        nLocalVariables;
    end
    
    methods
        function addHeader(packet, varargin)
            packet.msg = [packet.msg typecast(uint16(packet.counter), 'uint8') uint8(packet.packetType)];
            if packet.packetType == PacketType.DirectCommandReply || packet.packetType == PacketType.DirectCommandNoReply
                packet.addVariables(); 
            end
        end
        
        function addLength(packet)
            % Command.addLength Add command length
            %
            % Command.addLength() adds the command message length to the 
            % start of command object message.
            % 
            % Example::
            %            cmd.addLength()
            
           cmd.msg = [typecast( uint16(length(packet.msg)), 'uint8') packet.msg]; 
        end
        
        function opOUTPUT_START(packet,layer,nos)
            packet.packetType = PacketType.DirectCommandNoReply;
            packet.counter = 42;
            packet.nGlobalVariables = 0;
            packet.nLocalVariables = 0;
            opOUTPUT_START@DataStream(packet,layer,nos);
        end
    end
    
    methods (Access = private) 
        function addVariables(packet)
            packet.msg = [packet.msg typecast( bitor(bitshift(uint16(packet.nLocalVariables),10),uint16(packet.nGlobalVariables)), 'uint8')];
        end
    end
end

